
float4    light     : register(c0);
float4    eyepos    : register(c1);
float4    material  : register(c2);
float4x4  wvp       : register(c16);
float     time      : register(c32);
sampler t0;


void vs_0(
  in  float4 in_pos  : position,
  in  float3 in_nor  : normal,
  out float4 out_pos : position,
  out float4 out_col : color
)
{
  //Create Dekoboko
  if( in_pos.z < 0.5f ) {
    in_pos.xyz *= 1.0f;
  } else if( in_pos.z < 1.0f ) {
    in_pos.y *= 2.0f;
  } else {
    in_pos.y *= 1.0f;
  }

  if( in_pos.x < 0.5f ) {
    in_pos.xyz *= 1.0f;
  } else if( in_pos.x < 2.0f ) {
    in_pos.y *= 2.0f;
  } else {
    in_pos.y *= 1.0f;
  }
  
  //Base Vertex
  out_pos    = mul(in_pos, wvp);
  
  //Calc Color
  out_col     = material;
  out_col.r  += sin(time * in_pos.x);
  out_col.g  += sin(time * in_pos.y);
  out_col.b  += sin(time * in_pos.z);
}

void ps_0(
  in  float4 in_col  : color,
  out float4 out_col : color
)
{
  out_col = in_col - sin(in_col.x);
}

